<?php
class ElementorQodefProductList extends \Elementor\Widget_Base {

	public function get_name() {
		return 'qodef_product_list'; 
	}

	public function get_title() {
		return esc_html__( 'Product List', 'tonda-core' );
	}

	public function get_icon() {
		return 'tonda-elementor-custom-icon tonda-elementor-product-list';
	}

	public function get_categories() {
		return [ 'select' ];
	}

	protected function register_controls() {

		$this->start_controls_section(
			'general',
			[
				'label' => esc_html__( 'General', 'tonda-core' ),
				'tab'   => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);
		$this->add_control(
			'type',
			[
				'label'     => esc_html__( 'Type', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'standard' => esc_html__( 'Standard', 'tonda-core'), 
					'masonry' => esc_html__( 'Masonry', 'tonda-core')
				),
				'default' => 'standard'
			]
		);

		$this->add_control(
			'info_position',
			[
				'label'     => esc_html__( 'Product Info Position', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'info-below-image' => esc_html__( 'Info Below Image', 'tonda-core'), 
					'info-on-image' => esc_html__( 'Info On Image Hover', 'tonda-core')
				),
				'default' => 'info-below-image'
			]
		);

		$this->add_control(
			'number_of_posts',
			[
				'label'     => esc_html__( 'Number of Products', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::TEXT
			]
		);

		$this->add_control(
			'number_of_columns',
			[
				'label'     => esc_html__( 'Number of Columns', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'1' => esc_html__( 'One', 'tonda-core'), 
					'2' => esc_html__( 'Two', 'tonda-core'), 
					'3' => esc_html__( 'Three', 'tonda-core'), 
					'4' => esc_html__( 'Four', 'tonda-core'), 
					'5' => esc_html__( 'Five', 'tonda-core'), 
					'6' => esc_html__( 'Six', 'tonda-core')
				),
				'default' => '4'
			]
		);

		$this->add_control(
			'space_between_items',
			[
				'label'     => esc_html__( 'Space Between Items', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'huge' => esc_html__( 'Huge', 'tonda-core'), 
					'extra-large' => esc_html__( 'Extra Large', 'tonda-core'), 
					'large' => esc_html__( 'Large', 'tonda-core'), 
					'medium' => esc_html__( 'Medium', 'tonda-core'), 
					'normal' => esc_html__( 'Normal', 'tonda-core'), 
					'small' => esc_html__( 'Small', 'tonda-core'), 
					'tiny' => esc_html__( 'Tiny', 'tonda-core'), 
					'no' => esc_html__( 'No', 'tonda-core')
				),
				'default' => 'normal'
			]
		);

		$this->add_control(
			'orderby',
			[
				'label'     => esc_html__( 'Order By', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'date' => esc_html__( 'Date', 'tonda-core'), 
					'ID' => esc_html__( 'ID', 'tonda-core'), 
					'menu_order' => esc_html__( 'Menu Order', 'tonda-core'), 
					'name' => esc_html__( 'Post Name', 'tonda-core'), 
					'rand' => esc_html__( 'Random', 'tonda-core'), 
					'title' => esc_html__( 'Title', 'tonda-core'), 
					'on-sale' => esc_html__( 'On Sale', 'tonda-core')
				),
				'default' => 'date'
			]
		);

		$this->add_control(
			'order',
			[
				'label'     => esc_html__( 'Order', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'ASC' => esc_html__( 'ASC', 'tonda-core'), 
					'DESC' => esc_html__( 'DESC', 'tonda-core')
				),
				'default' => 'ASC'
			]
		);

		$this->add_control(
			'taxonomy_to_display',
			[
				'label'     => esc_html__( 'Choose Sorting Taxonomy', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'description' => esc_html__( 'If you would like to display only certain products, this is where you can select the criteria by which you would like to choose which products to display', 'tonda-core' ),
				'options' => array(
					'category' => esc_html__( 'Category', 'tonda-core'), 
					'tag' => esc_html__( 'Tag', 'tonda-core'), 
					'id' => esc_html__( 'Id', 'tonda-core')
				),
				'default' => 'category'
			]
		);

		$this->add_control(
			'taxonomy_values',
			[
				'label'     => esc_html__( 'Enter Taxonomy Values', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::TEXT,
				'description' => esc_html__( 'Separate values (category slugs, tags, or post IDs) with a comma', 'tonda-core' )
			]
		);

		$this->add_control(
			'image_size',
			[
				'label'     => esc_html__( 'Image Proportions', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'' => esc_html__( 'Default', 'tonda-core'), 
					'full' => esc_html__( 'Original', 'tonda-core'), 
					'square' => esc_html__( 'Square', 'tonda-core'), 
					'landscape' => esc_html__( 'Landscape', 'tonda-core'), 
					'portrait' => esc_html__( 'Portrait', 'tonda-core'), 
					'medium' => esc_html__( 'Medium', 'tonda-core'), 
					'large' => esc_html__( 'Large', 'tonda-core'), 
					'woocommerce_single' => esc_html__( 'Shop Single', 'tonda-core'), 
					'woocommerce_thumbnail' => esc_html__( 'Shop Thumbnail', 'tonda-core')
				),
				'default' => 'full',
				'condition' => [
					'type' => array( 'standard' )
				]
			]
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'product_info',
			[
				'label' => esc_html__( 'Product Info', 'tonda-core' ),
				'tab'   => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);
		$this->add_control(
			'display_title',
			[
				'label'     => esc_html__( 'Display Title', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'yes' => esc_html__( 'Yes', 'tonda-core'), 
					'no' => esc_html__( 'No', 'tonda-core')
				),
				'default' => 'yes'
			]
		);

		$this->add_control(
			'enable_variations',
			[
				'label'     => esc_html__( 'Enable Variations Selector', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'no' => esc_html__( 'No', 'tonda-core'), 
					'yes' => esc_html__( 'Yes', 'tonda-core')
				),
				'default' => 'no'
			]
		);

		$this->add_control(
			'display_category',
			[
				'label'     => esc_html__( 'Display Category', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'yes' => esc_html__( 'Yes', 'tonda-core'), 
					'no' => esc_html__( 'No', 'tonda-core')
				),
				'default' => 'yes'
			]
		);

		$this->add_control(
			'display_price',
			[
				'label'     => esc_html__( 'Display Price', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'yes' => esc_html__( 'Yes', 'tonda-core'), 
					'no' => esc_html__( 'No', 'tonda-core')
				),
				'default' => 'yes'
			]
		);

		$this->add_control(
			'display_sale_mark',
			[
				'label'     => esc_html__( 'Display Sale Mark', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'yes' => esc_html__( 'Yes', 'tonda-core'), 
					'no' => esc_html__( 'No', 'tonda-core')
				),
				'default' => 'yes'
			]
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'product_info_style',
			[
				'label' => esc_html__( 'Product Info Style', 'tonda-core' ),
				'tab'   => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);
		$this->add_control(
			'product_info_skin',
			[
				'label'     => esc_html__( 'Product Info Skin', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'default' => esc_html__( 'Default', 'tonda-core'), 
					'light' => esc_html__( 'Light', 'tonda-core'), 
					'dark' => esc_html__( 'Dark', 'tonda-core')
				),
				'default' => 'default',
				'condition' => [
					'info_position' => array( 'info-on-image' )
				]
			]
		);

		$this->add_control(
			'title_tag',
			[
				'label'     => esc_html__( 'Title Tag', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'' => esc_html__( 'Default', 'tonda-core'), 
					'h1' => esc_html__( 'h1', 'tonda-core'), 
					'h2' => esc_html__( 'h2', 'tonda-core'), 
					'h3' => esc_html__( 'h3', 'tonda-core'), 
					'h4' => esc_html__( 'h4', 'tonda-core'), 
					'h5' => esc_html__( 'h5', 'tonda-core'), 
					'h6' => esc_html__( 'h6', 'tonda-core')
				),
				'default' => 'h4',
				'condition' => [
					'display_title' => array( 'yes' )
				]
			]
		);

		$this->add_control(
			'title_transform',
			[
				'label'     => esc_html__( 'Title Text Transform', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'' => esc_html__( 'Default', 'tonda-core'), 
					'none' => esc_html__( 'None', 'tonda-core'), 
					'capitalize' => esc_html__( 'Capitalize', 'tonda-core'), 
					'uppercase' => esc_html__( 'Uppercase', 'tonda-core'), 
					'lowercase' => esc_html__( 'Lowercase', 'tonda-core'), 
					'initial' => esc_html__( 'Initial', 'tonda-core'), 
					'inherit' => esc_html__( 'Inherit', 'tonda-core')
				),
				'default' => '',
				'condition' => [
					'display_title' => array( 'yes' )
				]
			]
		);

		$this->add_control(
			'shader_background_color',
			[
				'label'     => esc_html__( 'Shader Background Color', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::COLOR
			]
		);

		$this->add_control(
			'info_bottom_text_align',
			[
				'label'     => esc_html__( 'Product Info Text Alignment', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options' => array(
					'' => esc_html__( 'Default', 'tonda-core'), 
					'left' => esc_html__( 'Left', 'tonda-core'), 
					'center' => esc_html__( 'Center', 'tonda-core'), 
					'right' => esc_html__( 'Right', 'tonda-core')
				),
				'default' => '',
				'condition' => [
					'info_position' => array( 'info-below-image' )
				]
			]
		);

		$this->add_control(
			'info_bottom_margin',
			[
				'label'     => esc_html__( 'Product Info Bottom Margin (px)', 'tonda-core' ),
				'type'      => \Elementor\Controls_Manager::TEXT,
				'condition' => [
					'info_position' => array( 'info-below-image' )
				]
			]
		);


		$this->end_controls_section();
	}
	public function render() {
        $default_atts = array(
            'type'                    => 'standard',
            'info_position'           => 'info-below-image',
            'number_of_posts'         => '8',
            'number_of_columns'       => '4',
            'space_between_items'     => 'normal',
            'orderby'                 => 'date',
            'order'                   => 'ASC',
            'taxonomy_to_display'     => 'category',
            'taxonomy_values'         => '',
            'image_size'              => 'full',
            'display_title'           => 'yes',
            'product_info_skin'       => '',
            'title_tag'               => 'h4',
            'title_transform'         => '',
            'display_category'        => 'yes',
            'display_price'           => 'yes',
            'display_button'          => 'yes',
            'shader_background_color' => '',
            'info_bottom_text_align'  => '',
            'info_bottom_margin'      => '',
            'enable_variations'       => 'no',
            'display_sale_mark'       => 'yes'
        );

        $params       = shortcode_atts( $default_atts, $this->get_settings_for_display() );


		
		$params['class_name']     = 'pli';
		$params['type']           = ! empty( $params['type'] ) ? $params['type'] : $default_atts['type'];
		$params['info_position']  = ! empty( $params['info_position'] ) ? $params['info_position'] : $default_atts['info_position'];
		$params['title_tag']      = ! empty( $params['title_tag'] ) ? $params['title_tag'] : $default_atts['title_tag'];

        $additional_params                   = array();
		$additional_params['holder_classes'] = $this->getHolderClasses( $params, $default_atts );
		
		$queryArray                        = $this->generateProductQueryArray( $params );
        $query_result                      = new \WP_Query( $queryArray );
		$additional_params['query_result'] = $query_result;
		
		$params['this_object'] = $this;
		
		echo tonda_select_get_woo_shortcode_module_template_part( 'templates/product-list', 'product-list', $params['type'], $params, $additional_params );
	}

	private function getHolderClasses( $params, $default_atts ) {
		$holderClasses   = array();
		$holderClasses[] = ! empty( $params['type'] ) ? 'qodef-' . $params['type'] . '-layout' : 'qodef-' . $default_atts['type'] . '-layout';
		$holderClasses[] = ! empty( $params['space_between_items'] ) ? 'qodef-' . $params['space_between_items'] . '-space' : 'qodef-' . $default_atts['space_between_items'] . '-space';
		$holderClasses[] = $this->getColumnNumberClass( $params );
		$holderClasses[] = ! empty( $params['info_position'] ) ? 'qodef-' . $params['info_position'] : 'qodef-' . $default_atts['info_position'];
		$holderClasses[] = ! empty( $params['product_info_skin'] ) ? 'qodef-product-info-' . $params['product_info_skin'] : '';
		
		return implode( ' ', $holderClasses );
	}

	private function getColumnNumberClass( $params ) {
		$columnsNumber = '';
		$columns       = $params['number_of_columns'];
		
		switch ( $columns ) {
			case 1:
				$columnsNumber = 'qodef-one-column';
				break;
			case 2:
				$columnsNumber = 'qodef-two-columns';
				break;
			case 3:
				$columnsNumber = 'qodef-three-columns';
				break;
			case 4:
				$columnsNumber = 'qodef-four-columns';
				break;
			case 5:
				$columnsNumber = 'qodef-five-columns';
				break;
			case 6:
				$columnsNumber = 'qodef-six-columns';
				break;
			default:
				$columnsNumber = 'qodef-four-columns';
				break;
		}
		
		return $columnsNumber;
	}

	private function generateProductQueryArray( $params ) {
		$queryArray = array(
			'post_status'         => 'publish',
			'post_type'           => 'product',
			'ignore_sticky_posts' => 1,
			'posts_per_page'      => $params['number_of_posts'],
			'orderby'             => $params['orderby'],
			'order'               => $params['order']
		);
		
		if ( $params['orderby'] === 'on-sale' ) {
			$queryArray['no_found_rows'] = 1;
			$queryArray['post__in']      = array_merge( array( 0 ), wc_get_product_ids_on_sale() );
		}
		
		if ( $params['taxonomy_to_display'] !== '' && $params['taxonomy_to_display'] === 'category' ) {
			$queryArray['product_cat'] = $params['taxonomy_values'];
		}
		
		if ( $params['taxonomy_to_display'] !== '' && $params['taxonomy_to_display'] === 'tag' ) {
			$queryArray['product_tag'] = $params['taxonomy_values'];
		}
		
		if ( $params['taxonomy_to_display'] !== '' && $params['taxonomy_to_display'] === 'id' ) {
			$idArray                = $params['taxonomy_values'];
			$ids                    = explode( ',', $idArray );
            $queryArray['orderby'] = 'post__in';
			$queryArray['post__in'] = $ids;
		}
		
		return $queryArray;
	}

	public function getItemClasses( $params ) {
		global $product;
		$itemClasses = array();
		
		$image_size_meta = get_post_meta( get_the_ID(), 'qodef_product_featured_image_size', true );
		
		if ( ! empty( $image_size_meta ) ) {
			$itemClasses[] = 'qodef-woo-fixed-masonry qodef-masonry-size-' . $image_size_meta;
		}
		
		if ( ! $product->is_in_stock() ) {
			$itemClasses[] = 'qodef-pli-outofstock';
		}
		
		return implode( ' ', $itemClasses );
	}

	public function getTitleStyles( $params ) {
		$styles = array();
		
		if ( ! empty( $params['title_transform'] ) ) {
			$styles[] = 'text-transform: ' . $params['title_transform'];
		}
		
		return implode( ';', $styles );
	}

	public function getShaderStyles( $params ) {
		$styles = array();
		
		if ( ! empty( $params['shader_background_color'] ) ) {
			$styles[] = 'background-color: ' . $params['shader_background_color'];
		}
		
		return implode( ';', $styles );
	}

	public function getTextWrapperStyles( $params ) {
		$styles = array();
		
		if ( ! empty( $params['info_bottom_text_align'] ) ) {
			$styles[] = 'text-align: ' . $params['info_bottom_text_align'];
		}
		
		if ( $params['info_bottom_margin'] !== '' ) {
			$styles[] = 'margin-bottom: ' . tonda_select_filter_px( $params['info_bottom_margin'] ) . 'px';
		}
		
		return implode( ';', $styles );
	}

}
\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new ElementorQodefProductList() );