<?php

if ( ! function_exists( 'tonda_select_include_woocommerce_shortcodes' ) ) {
	function tonda_select_include_woocommerce_shortcodes() {
		foreach ( glob( SELECT_FRAMEWORK_MODULES_ROOT_DIR . '/woocommerce/shortcodes/*/load.php' ) as $shortcode_load ) {
			include_once $shortcode_load;
		}
	}
	
	if ( tonda_select_core_plugin_installed() && tonda_core_is_theme_registered() ) {
		add_action( 'tonda_core_action_include_shortcodes_file', 'tonda_select_include_woocommerce_shortcodes' );
	}
}

if ( ! function_exists( 'tonda_select_set_product_list_icon_class_name_for_vc_shortcodes' ) ) {
	/**
	 * Function that set custom icon class name for product shortcodes to set our icon for Visual Composer shortcodes panel
	 */
	function tonda_select_set_product_list_icon_class_name_for_vc_shortcodes( $shortcodes_icon_class_array ) {
		$shortcodes_icon_class_array[] = '.icon-wpb-product-banner';
		$shortcodes_icon_class_array[] = '.icon-wpb-product-info';
		$shortcodes_icon_class_array[] = '.icon-wpb-product-list';
		$shortcodes_icon_class_array[] = '.icon-wpb-product-list-carousel';
		$shortcodes_icon_class_array[] = '.icon-wpb-product-list-simple';
		
		return $shortcodes_icon_class_array;
	}
	
	if ( tonda_select_core_plugin_installed() ) {
		add_filter( 'tonda_core_filter_add_vc_shortcodes_custom_icon_class', 'tonda_select_set_product_list_icon_class_name_for_vc_shortcodes' );
	}
}

// Load woo elementor widgets
if ( ! function_exists( 'tonda_select_include_woo_elementor_widgets_files' ) ) {
    /**
     * Loades all shortcodes by going through all folders that are placed directly in shortcodes folder
     */
    function tonda_select_include_woo_elementor_widgets_files() {
        if ( tonda_select_core_plugin_installed() && tonda_select_is_elementor_installed() && tonda_core_is_theme_registered() ) {
            foreach ( glob( SELECT_FRAMEWORK_MODULES_ROOT_DIR . '/woocommerce/shortcodes/*/elementor-*.php' ) as $shortcode_load ) {
                include_once $shortcode_load;
            }
        }
    }

    add_action( 'elementor/widgets/widgets_registered', 'tonda_select_include_woo_elementor_widgets_files' );
}